var canvas;
var cntx;
var cnvBackBuffer;
var cntxBackBuffer;

function init(){
    canvas=document.getElementById("visualisation");
    cntx=canvas.getContext("2d");
    cnvBackBuffer=document.getElementById("backBuffer");
    cntxBackBuffer=cnvBackBuffer.getContext("2d");
    
    showAppTitle();
    initialValues();
    initialiseGUI();
    initialiseEvents();
    selectResolution();
    drawBasicScreen();
}
      
function initialiseEvents(){
    $("#visualisation").on("mousemove touchend",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseMove();
    });

    $("#visualisation").on("mouseup touchend",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseUp();
    });
} 

function initialiseGUI(){
    Intro=document.getElementById("Intro");
    IntroHelp=document.getElementById("IntroHelp");
    for(var i=1;i<=5;i++){
        resolution.push(document.getElementById("resolution"+i));
    }
}

function initialValues(){
    $("#resolutionSlctr").val("800x600");
    TitleTOP=20;
    TitleWIDTH=550;
    TitleLEFT=(width-TitleWIDTH)/2;
    TitleHEIGHT=35;
    imgLogo=document.getElementById("Logo");
    width=canvas.width;
    height=canvas.height;

    BottomPanelTop=height-BottomPanelHeight;
    logoLeft=width-logoWidth-5;
    logoTop=BottomPanelTop+(BottomPanelHeight-logoHeight)/2;
}

function drawBasicScreen(){
    cntx.clearRect(0,0,canvas.width,canvas.height);
    
    drawIntroImage();
    drawLogoImage();
    drawInfoSwitch();
    var promptYCoord=BottomPanelTop+25;
    var prompt="";
    var prompt2="";
    var promptColor=LetterColor;
    if(IntroStep==1){
        $("#divResolutionSlctr").hide();
        if(ScreenTurnOffCounter>-1 && ScreenTurnOffCounter<4){
            if (!FirstScreen) prompt="Σβήνοντας την οθόνη δε μπορούμε να δούμε τίποτε! Ας την ξανανάψουμε. Πάτησε το κουμπί...";
        }
        else if(ScreenTurnOffCounter>3){
            promptColor="rgb(255,0,0)";
            prompt="Αν συνεχίσεις να αναβοσβήνεις την οθόνη στο τέλος θα την κάψεις! Πάτησε το κουμπί...";
        }        else{
            prompt="Ο Υπολογιστής είναι ήδη σε λειτουργία. Ας ανάψουμε και την oθόνη. Πάτησε το κουμπί...";
        }
    }
    else{
        if(DrawingFinished)drawCoordSwitch();
        prompt=resolutionMsg[selectedResolution];
        prompt2="Δοκίμασε να τροποποιήσεις την ανάλυση - Διερεύνησε την κλίμακα συντεταγμένων της οθόνης.";
    }
    if(coordsOn){
        drawMouseCoords();
    }
    cnvsWrite(promptColor,fontSize,"Arial",-1,promptYCoord,prompt);
    promptYCoord+=28;
    cnvsWrite(promptColor,fontSize-3,"Arial",-1,promptYCoord,prompt2);
    promptYCoord+=20;
}

function drawIntroImage(){
    var picTop=(height-Intro.height)/2;
    cntx.strokeStyle="black";
    //πλαίσιο καμβά
    cntx.rect(0,0,width,height);
    //άνω πλαίσιο
    cntx.rect(0,0,width,picTop-1);
    //κάτω πλαίσιο
    var lowRectTop=picTop+Intro.height+1;
    cntx.rect(0,lowRectTop,width,height-lowRectTop);

    cntx.stroke();
    cnvsWrite(LetterColor,35,"Arial",-1,TitleTOP+TitleHEIGHT,appTitle);
    if (infoOn){
        cntx.drawImage(IntroHelp,1,TopPanelHeight+1);
    }
    else {
        cntx.drawImage(Intro,1,TopPanelHeight+1);
    }
    if(IntroStep>1){
        cntxBackBuffer.drawImage(resolution[selectedResolution],0,0);
        if(DrawingFinished){
            $("#divResolutionSlctr").show();
            cnvsWrite("rgb(0,0,0)",fontSize,"Arial",30,130,"Επιλογή Ανάλυσης");
            cntx.drawImage(resolution[selectedResolution],VisibleLEFT,VisibleTOP);
        }
        else{
            timerLoop=setInterval(
                    function(){
                        drawSelectedImage();
                    },
                    simSpeed);
        }
    }
}

function drawSelectedImage(){
    imgData=cntxBackBuffer.getImageData(0,0,iw,ih);
    effFadeIn();
    cntx.putImageData(imgData,VisibleLEFT,VisibleTOP);
}

function effFadeIn(){
    imgOpacity+=10;
    if(imgOpacity>255){
        DrawingFinished=true;
        clearInterval(timerLoop);
        drawBasicScreen();
    }
    else{
        for(var i=3;i<imgData.data.length;i+=4){
            imgData.data[i]=imgOpacity;
        }
    }
}

function drawLogoImage(){
    cntx.drawImage(imgLogo,logoLeft,logoTop);
}

function showHTML(){
    window.open("index_DS_I_DS_II.html","_blank");
}

function cnvsWrite(clr,fontSize,fontName,txtX,txtY,txt){       
    cntx.font=fontSize+"px "+fontName;
    cntx.fillStyle=clr;
    if(txtX<0) txtX=(canvas.width-cntx.measureText(txt).width)/2;
    cntx.fillText(txt,txtX,txtY);
}

function handleMouseMove(){
    if (mx>=logoLeft && mx<logoLeft+logoWidth && my>=logoTop && my<logoTop+logoHeight){
        imgLogo=document.getElementById("LogoSel");
    }
    else {
        imgLogo=document.getElementById("Logo");
    }
    if (mx>=infoSwitchLeft && mx<infoSwitchLeft+switchSize && my>=infoSwitchTop && my<infoSwitchTop+switchSize){
        infoSwitchHover=true;
    }
    else {
        infoSwitchHover=false;
    }
    if (mx>=coordSwitchLeft && mx<coordSwitchLeft+switchSize && my>=coordSwitchTop && my<coordSwitchTop+switchSize){
        coordSwitchHover=true;
    }
    else {
        coordSwitchHover=false;
    }
    if (mx>=ScrButtonLeft && mx<ScrButtonLeft+ScrButtonWidth && my>=ScrButtonTop && my<ScrButtonTop+ScrButtonHeight) {
        canvas.style.cursor="pointer"; 
    }
    else if(infoSwitchHover){
        canvas.style.cursor="pointer";
    }
    else if(IntroStep>1 && coordSwitchHover){
        canvas.style.cursor="pointer";
    }
    else if(IntroStep!=1 && coordsOn && mx>=VisibleLEFT && mx<=VisibleRIGHT && my>=VisibleTOP && my<=VisibleBOTTOM){
        canvas.style.cursor="crosshair";
    }
    else {
        canvas.style.cursor="default";
    }


    if(DrawingFinished)drawBasicScreen();
    //console.log("mx="+mx+" , my="+my+" ,infoSwitchHover="+infoSwitchHover+" ,coordSwitchHover="+coordSwitchHover);
}

function handleMouseUp(){
    if (mx>=logoLeft && mx<logoLeft+logoWidth && my >=logoTop && my<logoTop+logoHeight) {
        showHTML();
    }
    
    if(infoSwitchHover){
        infoOn=!infoOn;
    }
    if(coordSwitchHover){
        coordsOn=!coordsOn;
    }
    if (mx>=ScrButtonLeft && mx<ScrButtonLeft+ScrButtonWidth && my>=ScrButtonTop && my<ScrButtonTop+ScrButtonHeight) {
        //stop();
        clearInterval(timerLoop);
        FirstScreen=false;
        DrawingFinished=false;
        imgOpacity=0;
        IntroStep=-IntroStep+3;
        if (IntroStep==1){
            ScreenTurnOffCounter++;
        }
    }
    drawBasicScreen();
}

function drawInfoSwitch(){
    if(infoSwitchHover){
        cntx.strokeStyle="#0000ff";
        cntx.fillStyle="#ffffff";
    }
    else{
        cntx.strokeStyle="#000000";
        cntx.fillStyle="#e1e1e1";
    }
    cntx.fillRect(infoSwitchLeft,infoSwitchTop,switchSize,switchSize);
    cntx.beginPath();
    cntx.rect(infoSwitchLeft,infoSwitchTop,switchSize,switchSize);
    if(infoOn){
        cntx.moveTo(infoSwitchLeft+switchSize,infoSwitchTop+switchSize);
        cntx.lineTo(infoSwitchLeft,infoSwitchTop);
        cntx.moveTo(infoSwitchLeft+switchSize,infoSwitchTop);
        cntx.lineTo(infoSwitchLeft,infoSwitchTop+switchSize);
    }
    cntx.stroke();
    cnvsWrite(LetterColor,fontSize-2,"Arial",infoSwitchLeft+switchSize+captionPadding,infoSwitchTop+switchSize,"Πληροφορίες");
}

function drawCoordSwitch(){
    if(coordSwitchHover){
        cntx.strokeStyle="#0000ff";
        cntx.fillStyle="#ffffff";
    }
    else{
        cntx.strokeStyle="#000000";
        cntx.fillStyle="#e1e1e1";
    }
    cntx.fillRect(coordSwitchLeft,coordSwitchTop,switchSize,switchSize);
    cntx.beginPath(); 
    cntx.rect(coordSwitchLeft,coordSwitchTop,switchSize,switchSize);
    if(coordsOn){
        cntx.moveTo(coordSwitchLeft+switchSize,coordSwitchTop+switchSize);
        cntx.lineTo(coordSwitchLeft,coordSwitchTop);
        cntx.moveTo(coordSwitchLeft+switchSize,coordSwitchTop);
        cntx.lineTo(coordSwitchLeft,coordSwitchTop+switchSize);
    }
    cntx.stroke();
    cnvsWrite(LetterColor,fontSize-2,"Arial",coordSwitchLeft+switchSize+captionPadding,coordSwitchTop+switchSize,"Συντεταγμένες");
}

function drawMouseCoords(){
    var ScrX,ScrY;
    var aCoefX,bCoefX,aCoefY,bCoefY;
    var aCoefScrX,bCoefScrX,aCoefScrY,bCoefScrY;
    var Xcoord,Ycoord;
    var Coords;
    if (IntroStep!=1 && mx>=VisibleLEFT && mx<=VisibleRIGHT && my>=VisibleTOP && my<=VisibleBOTTOM){
        var coordsFontSize=fontSize+4;
        cntx.font=coordsFontSize+"px Arial";
        //Μετατροπή σε συντεταγμένες οθόνης
        aCoefScrX=parseFloat(ScrWidth-1)/(VisibleRIGHT-VisibleLEFT);
        bCoefScrX=parseFloat(-aCoefScrX*VisibleLEFT);
        ScrX=parseInt(aCoefScrX*mx+bCoefScrX);
        aCoefScrY=parseFloat(ScrHeight-1)/(VisibleBOTTOM-VisibleTOP);
        bCoefScrY=parseFloat(-aCoefScrY*VisibleTOP);
        ScrY=parseInt(aCoefScrY*my+bCoefScrY);
        Coords="("+ScrX+","+ScrY+")";
        //Υπολογισμός συντεταγμένων εμφάνισης μηνύματος
        aCoefX=(parseFloat(VisibleRIGHT-VisibleLEFT-cntx.measureText(Coords).width)/(VisibleRIGHT-VisibleLEFT));
        bCoefX=parseFloat(VisibleLEFT*(1-aCoefX));
        aCoefY=(parseFloat(VisibleBOTTOM-VisibleTOP-fontSize)/(VisibleBOTTOM-VisibleTOP));
        bCoefY=parseFloat(VisibleBOTTOM*(1-aCoefY));
        Xcoord=parseInt(aCoefX*mx+bCoefX);
        Ycoord=parseInt(aCoefY*my+bCoefY);
        //Εμφάνιση μηνύματος
        cnvsWrite("rgb(255,255,255)",coordsFontSize,"Arial",Xcoord,Ycoord,Coords);
        cntx.fillStyle="rgb(0,0,0)";
    }
}

function selectResolution(){
    $("#divResolutionSlctr").hide();
    selectedResolution=$("#resolutionSlctr").prop("selectedIndex");
    var xPos=$("#resolutionSlctr").val().indexOf("x");
    ScrWidth=parseInt($("#resolutionSlctr").val().substr(0,xPos));
    ScrHeight=parseInt($("#resolutionSlctr").val().substr(xPos+1,$("#resolutionSlctr").val().length));
    cntxBackBuffer.drawImage(resolution[selectedResolution],0,0);
    iw=resolution[selectedResolution].width;
    ih=resolution[selectedResolution].height;
    DrawingFinished=false;
    imgOpacity=0;
console.log(imgOpacity);
    drawBasicScreen();
}